<?php

namespace patest\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfMerchandise.AddOnType ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfMerchandise.AddOnType
 * @subpackage Arrays
 */
class ArrayOfMerchandise_AddOnType extends AbstractStructArrayBase
{
    /**
     * The Merchandise_AddOnType
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \patest\StructType\Merchandise_AddOnType[]
     */
    public $Merchandise_AddOnType;
    /**
     * Constructor method for ArrayOfMerchandise.AddOnType
     * @uses ArrayOfMerchandise_AddOnType::setMerchandise_AddOnType()
     * @param \patest\StructType\Merchandise_AddOnType[] $merchandise_AddOnType
     */
    public function __construct(array $merchandise_AddOnType = array())
    {
        $this
            ->setMerchandise_AddOnType($merchandise_AddOnType);
    }
    /**
     * Get Merchandise_AddOnType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \patest\StructType\Merchandise_AddOnType[]|null
     */
    public function getMerchandise_AddOnType()
    {
        return isset($this->{'Merchandise.AddOnType'}) ? $this->{'Merchandise.AddOnType'} : null;
    }
    /**
     * This method is responsible for validating the values passed to the setMerchandise_AddOnType method
     * This method is willingly generated in order to preserve the one-line inline validation within the setMerchandise_AddOnType method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateMerchandise_AddOnTypeForArrayConstraintsFromSetMerchandise_AddOnType(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfMerchandise_AddOnTypeMerchandise_AddOnTypeItem) {
            // validation for constraint: itemType
            if (!$arrayOfMerchandise_AddOnTypeMerchandise_AddOnTypeItem instanceof \patest\StructType\Merchandise_AddOnType) {
                $invalidValues[] = is_object($arrayOfMerchandise_AddOnTypeMerchandise_AddOnTypeItem) ? get_class($arrayOfMerchandise_AddOnTypeMerchandise_AddOnTypeItem) : sprintf('%s(%s)', gettype($arrayOfMerchandise_AddOnTypeMerchandise_AddOnTypeItem), var_export($arrayOfMerchandise_AddOnTypeMerchandise_AddOnTypeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Merchandise_AddOnType property can only contain items of type \patest\StructType\Merchandise_AddOnType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Merchandise_AddOnType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \patest\StructType\Merchandise_AddOnType[] $merchandise_AddOnType
     * @return \patest\ArrayType\ArrayOfMerchandise_AddOnType
     */
    public function setMerchandise_AddOnType(array $merchandise_AddOnType = array())
    {
        // validation for constraint: array
        if ('' !== ($merchandise_AddOnTypeArrayErrorMessage = self::validateMerchandise_AddOnTypeForArrayConstraintsFromSetMerchandise_AddOnType($merchandise_AddOnType))) {
            throw new \InvalidArgumentException($merchandise_AddOnTypeArrayErrorMessage, __LINE__);
        }
        if (is_null($merchandise_AddOnType) || (is_array($merchandise_AddOnType) && empty($merchandise_AddOnType))) {
            unset($this->Merchandise_AddOnType, $this->{'Merchandise.AddOnType'});
        } else {
            $this->Merchandise_AddOnType = $this->{'Merchandise.AddOnType'} = $merchandise_AddOnType;
        }
        return $this;
    }
    /**
     * Add item to Merchandise_AddOnType value
     * @throws \InvalidArgumentException
     * @param \patest\StructType\Merchandise_AddOnType $item
     * @return \patest\ArrayType\ArrayOfMerchandise_AddOnType
     */
    public function addToMerchandise_AddOnType(\patest\StructType\Merchandise_AddOnType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \patest\StructType\Merchandise_AddOnType) {
            throw new \InvalidArgumentException(sprintf('The Merchandise_AddOnType property can only contain items of type \patest\StructType\Merchandise_AddOnType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Merchandise_AddOnType[] = $this->{'Merchandise.AddOnType'}[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \patest\StructType\Merchandise_AddOnType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \patest\StructType\Merchandise_AddOnType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \patest\StructType\Merchandise_AddOnType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \patest\StructType\Merchandise_AddOnType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \patest\StructType\Merchandise_AddOnType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Merchandise.AddOnType
     */
    public function getAttributeName()
    {
        return 'Merchandise.AddOnType';
    }
}
